## stress-ng-0.17.04.tar.gz

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2024 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.17.04
#
# Codename "pragmatic problem producer"
#

KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)

override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99

#
#  Building stress-vnni with less than -O2 causes breakage with
#  gcc-13.2, so remove then and ensure at least -O2 is used or
#  honour flags > -O2 if they are provided
#
VNNI_OFLAGS_REMOVE=-O0 -O1 -Og
VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))

#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	override CFLAGS += -O2
endif
ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
	override VNNI_CFLAGS += -O2
endif

#
# Debug flag
#
ifeq ($(DEBUG),1)
override CFLAGS += -g
endif

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))

PEDANTIC_FLAGS := \
	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE = $(shell uname -m)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
flag = -Wformat -fstack-protector-strong \
	-D_FORTIFY_SOURCE=2 -U_FORTIFY_SOURCE \
	-Werror=format-security
override CFLAGS += $(cc_supports_flag)
endif
endif

#
# Optimization flags
#
override CFLAGS += $(foreach flag,-fipa-pta,$(cc_supports_flag))

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
override CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(CC)),icc)
override CFLAGS += -no-inline-max-size -no-inline-max-total-size
override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(CC)),clang)
#override CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
override LDFLAGS += -static -z muldefs
override CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions


#
# Header files
#
HEADERS = \
	core-arch.h \
	core-affinity.h \
	core-asm-arm.h \
	core-asm-generic.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-asm-ret.h \
	core-attribute.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-clocksource.h \
	core-config-check.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-cpuidle.h \
	core-ftrace.h \
	core-hash.h \
	core-ignite-cpu.h \
	core-interrupts.h \
	core-io-priority.h \
	core-job.h \
	core-helper.h \
	core-killpid.h \
	core-klog.h \
	core-limit.h \
	core-lock.h \
	core-log.h \
	core-madvise.h \
	core-mlock.h \
	core-mmap.h \
	core-mincore.h \
	core-module.h \
	core-mounts.h \
	core-mwc.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-numa.h \
	core-opts.h \
	core-out-of-memory.h \
	core-parse-opts.h \
	core-perf.h \
	core-pragma.h \
	core-processes.h \
	core-pthread.h \
	core-put.h \
	core-resources.h \
	core-sched.h \
	core-setting.h \
	core-shared-heap.h \
	core-shim.h \
	core-smart.h \
	core-sort.h \
	core-stressors.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-time.h \
	core-try-open.h \
	core-vecmath.h \
	core-version.h \
	core-vmstat.h \
	stress-af-alg-defconfigs.h \
	stress-eigen-ops.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-acl.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-cgroup.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-eigen.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fma.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \
	stress-handle.c \
	stress-hash.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-io.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-jpeg.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-kvm.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-led.c \
	stress-link.c \
	stress-list.c \
	stress-llc-affinity.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-metamix.c \
	stress-mincore.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-module.c \
	stress-mprotect.c \
	stress-mpfr.c \
	stress-mq.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-msyncmany.c \
	stress-munmap.c \
	stress-mutex.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pagemove.c \
	stress-pageswap.c \
	stress-pci.c \
	stress-personality.c \
	stress-peterson.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-plugin.c \
	stress-poll.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-priv-instr.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-race-sched.c \
	stress-radixsort.c \
	stress-randlist.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-regs.c \
	stress-remap.c \
	stress-rename.c \
	stress-resched.c \
	stress-resources.c \
	stress-revio.c \
	stress-ring-pipe.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rotate.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedmix.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigbus.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-sigxcpu.c \
	stress-sigxfsz.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-sparsematrix.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-syncload.c \
	stress-sysbadaddr.c \
	stress-syscall.c \
	stress-sysinfo.c \
	stress-sysinval.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-touch.c \
	stress-tree.c \
	stress-trig.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-tun.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-umount.c \
	stress-unshare.c \
	stress-uprobe.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-usersyscall.c \
	stress-utime.c \
	stress-vdso.c \
	stress-vecfp.c \
	stress-vecmath.c \
	stress-vecshuf.c \
	stress-vecwide.c \
	stress-verity.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-addr.c \
	stress-vm-rw.c \
	stress-vm-segv.c \
	stress-vm-splice.c \
	stress-vma.c \
	stress-vnni.c \
	stress-wait.c \
	stress-waitcpu.c \
	stress-watchdog.c \
	stress-wcs.c \
	stress-workload.c \
	stress-x86cpuid.c \
	stress-x86syscall.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \


#
#  Build time core source files
#
CORE_SRC_GEN = \
	core-config.c

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-asm-ret.c \
	core-cpu.c \
	core-cpu-cache.c \
	core-cpuidle.c \
	core-clocksource.c \
	core-config-check.c \
	core-hash.c \
	core-helper.c \
	core-ignite-cpu.c \
	core-interrupts.c \
	core-io-uring.c \
	core-io-priority.c \
	core-job.c \
	core-killpid.c \
	core-klog.c \
	core-limit.c \
	core-lock.c \
	core-log.c \
	core-madvise.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-module.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-numa.c \
	core-opts.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-processes.c \
	core-resources.c \
	core-sched.c \
	core-setting.c \
	core-shared-heap.c \
	core-shim.c \
	core-smart.c \
	core-sort.c \
	core-thermal-zone.c \
	core-time.c \

=== debian/changelog ===
stress-ng (0.17.04-1) unstable; urgency=medium

  [Munehisa Kamata]
  * README.md: fix a typo in the contributor name
  * stress-acl: Fix stress_acl_info definition

  [Colin Ian King]
  * Makefile: bump version, change code name
  * README.md: add Cygwin to supported systems
  * kernel-coverage: add longer duration sysbadaddr test
  * stress-pthread: disable pthread_sigqueue call for CYGWIN
  * stress-tree: disable RB trees for CYGWIN
  * stress-sparsematrix: disable RB trees for CYGWIN
  * core-helper: add _start workaround for CYGWIN
  * core-shim: fix setdomainname check on HAVE_SETDOMAINNAME
  * stress-dir: don't reference non-POSIX d_reclen for CYGWIN
  * stress-mmapfork: use stress_mmap_populate for MAP_POPULATE
  * stress-xattr: workaround ENODATA not being defined for NetBSD
  * stress-metamix: voidify parameter temp_dir if O_DIRECTORY is not defined
  * core-time: voidify parameter dnow, cleans up Dilos build warning
  * stress-sysbadaddr: fix another valid fd check, should be >= 0
  * stress-sysbadaddr: fix valid fd check, should be >= 0
  * stress-sysbadaddr: close fdin rather than fdout on fdout open failure
  * stress-sysfs: use SCNu16 formate specifier for sscanf uint16_t
  * stress-sock: remove shadowed declaration of variable i
  * stress-vdso: add clock_getres
  * stress-sysinval: set dirfd mode, gid and uid back to original setting
  * stress-sigxfsz: retry setrlimit with smaller size if limit is too large
  * stress-copy-file: replace sizeof(char) with 8
  * stress-copy-file: fix the max off_t, it's signed to cater for this
  * stress-sysbadaddr: use shim_cacheflush instead of direct system call
  * stress-sysbadaddr: pass different addresses to ppoll
  * stress-af-alg-defconfigs: re-order and remove blank lines
  * stress-mmap: add mprotect EACCESS error check for NetBSD
  * stress-metamix: add EBADF on fdatasync on read-only fd
  * stress-metamix: fix incorrect EBADF check
  * stress-metamix: ignore EBADF on fdatasync on read-only file
  * stress-ng: don't call mprotect if it does not exist
  * stress-syscall: add comment explaining why shell sort is used instead
    of qsort
  * stress-sysbadaddr: use VOID_RET for typed voidification of system call
    returns
  * Update copyright year to 2024
  * Manual: remove . in Eigen description
  * stress-sock: exercise SO_SOCKET SO_* opts that return int type values
  * stress-sysbadaddr: only increment counter if a syscall is to be made
  * stress-sysbadaddr: avoid exercising system calls that will not fail
  * stress-sysbadaddr: add some more xattr system calls
  * stress-sysbadaddr: bad_fstat: exercise fstat on temp dir
  * stress-sysbadaddr: add copy_file_range
  * stress-sysbadaddr: add missing MIPS cacheflush system call
  * stress-syscall: add missing MIPS cacheflush system call
  * stress-sysbadaddr: exercise shim'd and non-shim'd syscalls
  * stress-sysbadaddr: exericse system call parameters with range of
    parameters
  * stress-sysbadaddr: only respawn child when bad addr breaks system call
  * core-version: define EQUAL_GNUC for all compiler times
  * stress-radixsort: remove array size specifiers to fix tcc build failures
  * core-builtin: add shim wrapper for __builtin_assume_aligned()
  * core-cache: add missing tab to clean up \ alignments
  * stress-vecshuf: remove redundant variables total_ops and total_bytes
  * stress-numa: Fix spelling mistake in comment
  * stress-memthrash: remove trailing space at end of line
  * README.md: update contributors list
  * stress-syscall: add the --syscall-top N option to report top N fastest
    syscalls
  * Manual: fix typo "fasted" -> "fastest"
  * stress-radixsort: reduce memory bandwidth by making length 2 bytes
  * stress-radixsort: clean up casting in IDX and IDX_T macros
  * stress-radixsort: remove signed conversions in radix_strlen
  * stress-radixsort: offset digit counter by 1
  * stress-radixsort: optimize radixsort
  * stress-radixsort: add nonlibc implementation of radixsort
  * stress-heapsort: add new --heapsort-method option to help
  * stress-mergesort: add new --mergesort-method option to help
  * stress-mergesort: add some more memory copying optimizations
  * stress-mergesort: optimize for 4 byte data
  * stress-mergesort: remove base_ptr, replace with base
  * stress-mergesort: optimize copying of lhs and rhs to base
  * stress-mergesort: add missing base_ptr increment
  * stress-mergesort: optimize lhs and rhs copying
  * stress-mergesort: add nonlibc implementation of mergesort
  * stress-heapsort: optimize copy and swap for common size cases
  * stress-heapsort: add nonlibc implementation of heapsort
  * Makefile: add cc_supports_flag to simplify CFLAGS checking
  * Makefile: add gcc optimization flag -fipa-pta
  * stress-sysfs: exercise test resume command for /sys/power/disk
  * stress-pty: exercise cfgetispeed and cfgetospeed on leader and follower
  * stress-vecshuf: report shuffle rates as Harmonic Mean
  * stress-sysinval: add map_shadow_stack system call
  * stress-syscall: add map_shadow_stack call
  * core-*: add more comments
  * core-helper: assign val2 to avoid any static analysis warnings
  * stress-acl: add randomized acl attribute order shuffling with --acl-rand
  * Makefile.config: Fix incorrect addition of -DSTRFUNC to LDFLAGS
  * stress-ng: initialize values to 0.0 rather -1.0
  * stress-acl: exercise all ACL types, ACL_TYPE_ACCESS and ACL_TYPE_DEFAULT
  * core-shim: shim_kill: don't allow SIGKILL on pid -1
  * stress-ng: don't kill entire group or pid 1 (init)
  * stress-acl: uppercase ACL in help text
  * stress-acl: add ACL set vs get verification
  * stress_acl: rename acl functions, prefix with stress_
  * stress-acl: exercise acl_get_file and add metrics for this
  * kernel-coverage: enable acl for reiserfs
  * README.md: add another link to a research paper
  * stress-open: add open using all the possible file modes
  * stress-acl: compute and cache all valid ACLs to improve performance


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               libacl1-dev,
               zlib1g-dev,
               libbsd-dev,
               libeigen3-dev,
               libgcrypt20-dev,
               libjpeg-dev,
               libmpfr-dev,
               libkeyutils-dev [linux-any],
               libapparmor-dev [linux-any],
               apparmor [linux-any],
               libaio-dev [linux-any],
               libcap-dev [linux-any],
               libsctp-dev [linux-any],
               libipsec-mb-dev [amd64],
               libjudy-dev,
               libatomic1 [linux-any],
               libkmod-dev [linux-any],
               libxxhash-dev,
               libglvnd-dev,
               libgbm-dev [linux-any]
Homepage: https://github.com/ColinIanKing/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.
